<?php

defined('JPATH_BASE') or die;

// Required objects
$app 	= JFactory::getApplication();
$doc 	= JFactory::getDocument();
$jinput = $app->input;

// Get URL parameters
$itemId = (int) $jinput->get('Itemid', 0);
$option = $jinput->get('option', '');
$view   = $jinput->get('view', '');
$layout = $jinput->get('layout', '');

/**
 * ==================================================
 * Frontpage check
 * ==================================================
 */
$isFrontpage = false;
$menu = $app->getMenu();
if ($menu->getActive() == $menu->getDefault())
{
	$isFrontpage = true;
}

/**
 * ==================================================
 * Bootstrap
 * ==================================================
 */
// Load configuration
$loadBootstrap 	= $this->params->get('loadBootstrap', 1);
$bsMode 		= '-' . $this->params->get('bsMode', 'fluid');
if ($bsMode == '-static')
{
	$bsMode = '';
}

// Calculate mainColumns
$mainColumnWidth 	= 12;
$leftColumnWidth 	= $this->params->get('leftColumnWidth', 3);
$rightColumnWidth 	= $this->params->get('rightColumnWidth', 3);
if ($this->countModules('left'))
{
	$mainColumnWidth -= $leftColumnWidth;
}
if ($this->countModules('right'))
{
	$mainColumnWidth -= $rightColumnWidth;
}

/**
 * ==================================================
 * Google fonts
 * ==================================================
 */
$gfontsCssRequired = false;
$gfontsCssLink     = 'http://fonts.googleapis.com/css?family=';
$gfontsCss         = "\n<style type='text/css'>\n<!--";

for ($i = 1; $i < 5; $i++)
{

	// Generate variable for google font value
	$gfontValue  = 'gfontValue' . $i;
	$$gfontValue = $this->params->get('google-font' . $i, '');

	// Generate variable for google font name
	$gfontName  = 'gfontName' . $i;
	$$gfontName = str_replace('+', ' ', $$gfontValue);

	// Get the css class assigned to the google font
	$gfontCssClass = $this->params->get('google-font' . $i . '-class', '');

	// User has selected a google font and set a class name add the css class
	if ($$gfontName != '' && !empty($gfontCssClass))
	{
		if (!$gfontsCssRequired )
		{
			$gfontsCssRequired = true;
		}
		else
		{
			$gfontsCssLink .= '|';
		}
		$gfontsCssLink 	.= $$gfontValue;
		$gfontsCss 		.= "\n" . $this->params->get('google-font' . $i . '-class') . " { font-family:'" . $$gfontName . "' !important; "
							. $this->params->get('google-font' . $i . '-css') . "}";
	}
}
$gfontsCss .= "\n -->
    \n</style>
";

// If no active google fonts avoid empty styles
if (!$gfontsCssRequired)
{
	$gfontsCssLink = null;
	$gfontsCss     = null;
}

/**
 * ==================================================
 * Load jQuery
 * ==================================================
 */
$loadJquery = $this->params->get('loadJquery', 0);
if ($loadJquery)
{
	switch ($loadJquery)
	{
		// Load jQuery locally
		case 1:
			$jquerySrc = $this->baseurl . "/templates/" . $this->template . "/js/jquery-1.7.2.min.js";
			break;

		// Load jQuery from Google
		default:
			$jquerySrc = 'http://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js';
		break;
	}
}

/**
 * ==================================================
 * Load customCss
 * ==================================================
 */
$customCssFile = JPATH_SITE . '/templates/' . $this->template . '/css/custom.css';
if (file_exists($customCssFile))
{
	$customCssFile = $this->baseurl . '/templates/' . $this->template . '/css/custom.css';
}
else
{
	$customCssFile = null;
}

/**
 * ==================================================
 * Disable mootools-more except for selected itemids to solve bootstrap conflicts
 * ==================================================
 */
$enabledItemids        = array();
$enabledMootoolsString = $this->params->get('mootoolsItemids', '');
$editingMootools       = $this->params->get('editingMootools', 1);

// Decode the enabled Itemids array
if ($enabledMootoolsString != '')
{
	$enabledItemids = explode(',', $enabledMootoolsString);
}

if ($editingMootools && ($option != 'com_content' || $view != 'form' || $layout != 'edit'))
{
	$editingMootools = 0;
}

// If the itemId isn't in items that need mootools disable mootools
if (!$editingMootools && (empty($enabledItemids) || empty($itemId) || !in_array($itemId, $enabledItemids)))
{
		// Disable mootools javascript
		unset($doc->_scripts[$this->baseurl . '/media/system/js/mootools-core.js']);
		unset($doc->_scripts[$this->baseurl . '/media/system/js/mootools-more.js']);
		unset($doc->_scripts[$this->baseurl . '/media/system/js/core.js']);
		unset($doc->_scripts[$this->baseurl . '/media/system/js/caption.js']);
		unset($doc->_scripts[$this->baseurl . '/media/system/js/modal.js']);
		unset($doc->_scripts[$this->baseurl . '/media/system/js/mootools.js']);
		unset($doc->_scripts[$this->baseurl . '/plugins/system/mtupgrade/mootools.js']);

		// Disable css stylesheets
		unset($doc->_styleSheets[$this->baseurl . '/media/system/css/modal.css']);
}

/**
 * ==================================================
 * LESS
 * ==================================================
 */
$lessCompile = $this->params->get('lessCompile', 0);
if ($lessCompile)
{
	$cssOutputDir = dirname(__FILE__) . '/../css';
	require_once dirname(__FILE__) . '/../libraries/lessphp/lessc.inc.php';
	$less = new lessc;
	$less->setFormatter("compressed");
	if ($loadBootstrap)
	{
		$bsLessDir =  dirname(__FILE__) . '/../less/bootstrap';
		$less->compileFile(	$bsLessDir . '/bootstrap.less', $cssOutputDir . "/bootstrap.min.css" );
		$less->compileFile(	$bsLessDir . '/responsive.less', $cssOutputDir . "/bootstrap-responsive.min.css" );
	}
}
